; 
    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc

    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\msvcrt.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\msvcrt.lib

    include UTILITY.INC
    includelib UTILITY.LIB

    include \masm32\macros\macros.asm

    include timers.asm

; 
    .data
      str1 db "my other brother darryl",0
    .code
; 
start: 
; 
    ;repeat 3          ; Used to check sensitivity to alignment
    ;  nop
    ;endm

    invoke StrLen, ADDR str1
    push  eax
    print "StrLen return value : "
    pop   eax
    print ustr$(eax),13,10

    invoke StrLen2, ADDR str1
    push  eax
    print "StrLen2 return value : "
    pop   eax
    print ustr$(eax),13,10

    invoke StrLenA, ADDR str1
    push  eax
    print "StrLenA return value : "
    pop   eax
    print ustr$(eax),13,10,13,10


    print "StrLen : "
    counter_begin 10000000, HIGH_PRIORITY_CLASS
      invoke StrLen, ADDR str1
    counter_end
    print ustr$(eax)
    print chr$(" cycles",13,10)

    print "StrLen2 : "
    counter_begin 10000000, HIGH_PRIORITY_CLASS
      invoke StrLen2, ADDR str1
    counter_end
    print ustr$(eax)
    print chr$(" cycles",13,10)

    print "StrLenA : "
    counter_begin 10000000, HIGH_PRIORITY_CLASS
      invoke StrLenA, ADDR str1
    counter_end
    print ustr$(eax)
    print chr$(" cycles",13,10,13,10)


    print "StrLen offset: "
    mov eax, offset StrLen
    print ustr$(eax)
    print chr$(13,10)

    print "StrLen2 offset: "
    mov eax, offset StrLen2
    print ustr$(eax)
    print chr$(13,10)

    print "StrLenA offset: "
    mov eax, offset StrLenA
    print ustr$(eax)
    print chr$(13,10)


    mov   eax, input(13,10,"Press enter to exit...")
    exit
; 
end start
